<?php

namespace Teknisa\CADEST\Modules\Produto\Controllers;

use \Zeedhi\Framework\DTO\Request;
use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DataSource\ParameterBag;
use \Zeedhi\Framework\DataSource\DataSet;
use \Teknisa\Libs\Service\CRUD as CrudService;

class ArvoreProduto extends \Teknisa\CADEST\Controllers\TeknisaCrud{

    protected $dataSourceName = 'prodarvoreprod';

    function __construct(CrudService $crudService, ParameterBag $parameterBag) {
        parent::__construct($crudService, $parameterBag);
	}

	public function save(DTO\Request $request, DTO\Response $response){
            $row = $request->getRow();

            if($row['__is_new']){
                $condition = array(
                    array(
                        "columnName" => "CDPRODUTO",
                        "operator" => "=",
                        "value" => $row["CDPRODUTO"]
                    ),
                    array(
                        "columnName" => "NRTPARVPROD",
                        "operator" => "=",
                        "value" => $row["NRTPARVPROD"]
                    )
                );

            $filterCriteria = new FilterCriteria($this->dataSourceName, $condition);
            $dataSet = $this->dataSourceManager->findBy($filterCriteria);
            $registrosEncontrados = $dataSet->getRows();

            if(empty($registrosEncontrados)){
                parent::save($request, $response);
            } else {
                $response->setError(new DTO\Response\Error($this->messages->getMessage('APP-00002'), 1));
            }
        } else {
            parent::save($request, $response);
        }
    }
}